VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4215
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4215
   LinkTopic       =   "Form1"
   ScaleHeight     =   4215
   ScaleWidth      =   4215
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture1 
      Height          =   4215
      Left            =   0
      ScaleHeight     =   4155
      ScaleWidth      =   4155
      TabIndex        =   0
      Top             =   0
      Width           =   4215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Return F(X, Y).
Private Function F(ByVal X As Single, ByVal Y As Single) As Single
    F = X * X * X * X - 2 * X * X + Y * Y
End Function
' Return the partial derivative of dF/dX.
Private Function dFdX(ByVal X As Single, ByVal Y As Single) As Single
    dFdX = 4 * X * X * X - 4 * X
End Function
' Return the partial derivative of dF/dY.
Private Function dFdY(ByVal X As Single, ByVal Y As Single) As Single
    dFdY = 2 * Y
End Function
' Find a point on the curve close to this one.
Private Sub FindPointOnCurve(ByRef X As Single, ByRef Y As Single, ByVal level As Single, Optional ByVal start_x As Single = 0.1, Optional ByVal start_y As Single = 0.2, Optional ByVal tolerance As Single = 0.01, Optional ByVal initial_delta As Single = 0.1)
Dim dZ As Single
Dim dist As Single
Dim delta As Single
Dim F_XY As Single
Dim dx As Single
Dim dy As Single
Dim direction As Integer

    ' Start at the starting point.
    X = start_x
    Y = start_y
    delta = initial_delta

    ' Repeat until we have a decent solution.
    Do
        ' See how far off we are.
        F_XY = F(X, Y)
        dZ = level - F_XY
        If Abs(dZ) < tolerance Then Exit Do

        ' See if we are switching directions.
        If Sgn(dZ) <> direction Then
            ' We are switching directions. Decrease delta.
            delta = delta / 2
            direction = Sgn(dZ)
        End If

        ' Get the gradient.
        Gradient X, Y, dx, dy
        If Abs(dx) + Abs(dy) < 0.001 Then Exit Do

        ' Move in the right direction.
        X = X + dx * delta * direction
        Y = Y + dy * delta * direction
'Debug.Print X; Y
    Loop
End Sub
' Return the gradient at this point.
Private Sub Gradient(ByVal X As Single, ByVal Y As Single, ByRef dx As Single, ByRef dy As Single)
Dim dist As Single

    dx = dFdX(X, Y)
    dy = dFdY(X, Y)
    dist = Sqr(dx * dx + dy * dy)
    If Abs(dist) < 0.0001 Then
        dx = 0
        dy = 0
    Else
        dx = dx / dist
        dy = dy / dist
    End If
End Sub
' Plot the level curve F(X, Y) = level.
Private Sub PlotLevelCurve(ByVal pic As PictureBox, ByVal level As Single, ByVal xmin As Single, ByVal xmax As Single, ByVal ymin As Single, ByVal ymax As Single, Optional step_size As Single = 0.1, Optional ByVal start_x As Single = 1#, Optional ByVal start_y As Single = 1#, Optional ByVal tolerance As Single = 0.02)
#Const SHOW_TICS = False

Dim num_points As Integer
Dim X0 As Single
Dim Y0 As Single
Dim X As Single
Dim Y As Single
Dim dx As Single
Dim dy As Single

    ' Find a point (X0, Y0) on the level curve.
    FindPointOnCurve X0, Y0, level, start_x, start_y, tolerance

    ' Start here.
    pic.CurrentX = X0
    pic.CurrentY = Y0
    num_points = 1

    ' Start following the level curve.
    X = X0
    Y = Y0
    Do
        ' Find the next point along the curve.
        Gradient X, Y, dx, dy
        If Abs(dx) + Abs(dy) < 0.001 Then Exit Do
        X = X + dy * step_size
        Y = Y - dx * step_size
        FindPointOnCurve X, Y, level, X, Y, tolerance

        ' Draw to this point.
        pic.Line -(X, Y)
        #If SHOW_TICS Then
            pic.Line -Step(dx * 0.1, dy * 0.1)
            pic.Line -Step(-dx * 0.1, -dy * 0.1)
        #End If
        num_points = num_points + 1

        ' See if the point is outside the drawing area.
        If X < xmin Or X > xmax Or _
           Y < ymin Or Y > ymax _
                Then Exit Do

        ' If we have gone at least 4 points, see if this
        ' is where we started.
        If num_points >= 4 Then
            If Sqr((X0 - X) * (X0 - X) + (Y0 - Y) * (Y0 - Y)) <= step_size * 1.1 Then
                pic.Line -(X0, Y0)
                Exit Do
            End If
        End If
    Loop
End Sub
Private Sub Form_Load()
Dim level As Integer

    Show

    Picture1.AutoRedraw = True
    Picture1.ScaleLeft = -2
    Picture1.ScaleWidth = 4
    Picture1.ScaleTop = 2
    Picture1.ScaleHeight = -4

    For level = -3 To 10
        PlotLevelCurve Picture1, level / 4, -4, 4, -4, 4, 0.05, 1, 1, 0.002
    Next level

    ' Get the second set of curves in the left peak.
    For level = -3 To -1
        PlotLevelCurve Picture1, level / 4, -4, 4, -4, 4, 0.05, -1, 1, 0.002
    Next level
End Sub
